import * as mc from "@minecraft/server";
import * as ItemComponent from "./wg/items.js";
import * as Jutsu from "./wg/jutsus.js";
import "./wg/attack.js";
//import "./wg/chat.js";
import { /*damage, */title, menu, projetil, entities } from "./wg/commands.js";
import "./wg/events.js";
import "./wg/mission.js";
import "./wg/stats.js";
import "./wg/structures.js";

mc.world.beforeEvents.worldInitialize.subscribe(event => {
	const itemComponentRegistry = event.itemComponentRegistry;
	const blockComponentRegistry = event.blockComponentRegistry;

	/*itemComponentRegistry.registerCustomComponent("wesl3y:samehada",{onHitEntity: arg => {ItemComponent.cutlass_poison_on_hit(arg.hitEntity);}});*/
	itemComponentRegistry.registerCustomComponent("wesl3y:menu",{onUse: arg => {ItemComponent.menu(arg.source);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:menu_uchiha",{onUse: arg => {ItemComponent.menu_uchiha(arg.source);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:menu_hyuga",{onUse: arg => {ItemComponent.menu_hyuga(arg.source);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:menu_modes",{onUse: arg => {ItemComponent.menu_modes(arg.source);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:chakra_pill",{onConsume: arg => {ItemComponent.chakra_pill(arg.source);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:ramen",{onConsume: arg => {ItemComponent.ramen(arg.source);}});

	itemComponentRegistry.registerCustomComponent("wesl3y:sharingan_genjutsu",{onUse: arg => {Jutsu.sharingan_genjutsu(arg.source);}});
	
	itemComponentRegistry.registerCustomComponent("wesl3y:katon_fire_ball",{onUse: arg => {Jutsu.fire_ball(arg.source);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:katon_phoenix_flower",{onUse: arg => {Jutsu.phoenix_flower(arg.source);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:katon_explosive_clone",{onUse: arg => {Jutsu.explosive_clone(arg.source);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:katon_fire_dragon",{onUse: arg => {Jutsu.fire_dragon(arg.source);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:doton_earth_spears",{onUse: arg => {Jutsu.earth_spears(arg.source);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:doton_earth_golem",{onUse: arg => {Jutsu.earth_golem(arg.source);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:doton_earth_wall",{onUse: arg => {Jutsu.earth_wall(arg.source);}});
	itemComponentRegistry.registerCustomComponent("wesl3y:doton_underworld_swamp",{onUse: arg => {Jutsu.underworld_swamp(arg.source);}});
	
	

	//blockComponentRegistry.registerCustomComponent("wesl3y:block_despawn_tick",{onTick: arg => {ItemComponent.block_despawn_tick(arg.block);}});
	blockComponentRegistry.registerCustomComponent("wesl3y:doton_despawn_tick",{onTick: arg => {ItemComponent.doton_despawn_tick(arg.block);}});
	blockComponentRegistry.registerCustomComponent("wesl3y:konoha_tick",{onTick: arg => {ItemComponent.konoha_tick(arg.block);}});
	blockComponentRegistry.registerCustomComponent("wesl3y:mud_despawn_tick",{onTick: arg => {ItemComponent.mud_despawn_tick(arg.block);}});
	blockComponentRegistry.registerCustomComponent("wesl3y:itachi_tick_block",{onTick: arg => {ItemComponent.itachi_tick_block(arg.block,arg.player,arg.permutationToPlace);}});
1});

mc.system.runInterval(() => {
  for (const player of mc.world.getPlayers()) {
    //damage(player);
    title(player)
    menu(player);
    /*if (player.hasTag("uchiha") && player.getComponent("health")?.currentValue == (Math.floor(player.getComponent("health")?.effectiveMax / 4)) && getScore("level", player) >= 10 && getScore("level", player) <= 19) {
      player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"lock.sharingan1"}]}`);
      player.runCommandAsync("event entity @s wesl3y:sharingan1");
    }*/
    player.nameTag = `${player.name}\nHp: §e${Math.floor(player.getComponent("health")?.currentValue)}§f`;
  }
});

mc.system.runInterval(() => {
  for (const player of mc.world.getPlayers()) {
    for (const entity of mc.world.getDimension("overworld").getEntities()) {
      projetil(entity, player);
      entities(entity);
    }
  }
}, 10);
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                      
                                                                                                                                      
                                      
                                      
                                      
                                      
                                                                                                                          