import * as mc from "@minecraft/server";

function generateStructure(player, x, y, z, radius, timer, dynamicProperty, structureName, message) {
  const distance = Math.sqrt(Math.pow(player.location.x - x, 2) + Math.pow(player.location.z - z, 2));
  const propertyValue = mc.world.getDynamicProperty(dynamicProperty);

  if (propertyValue != 1 && distance <= radius && player.isOnGround && !player.isInWater) {
    mc.world.setDynamicProperty(dynamicProperty, 1);
    player.runCommandAsync(`structure load mystructure:${structureName} ${x - 32} ${y} ${z - 32} 0_degrees none layer_by_layer ${timer}`);
    console.warn(`structure load mystructure:${structureName} ${x - 32} ${y} ${z - 32} 0_degrees none layer_by_layer 10`);
    player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"§c${message}"}]}`);
  }
}

mc.system.runInterval(() => {
  for (const player of mc.world.getPlayers()) {
    generateStructure(player, -450, Math.floor(player.location.y - 2), 760, 10, 20, "wesl3y:itachi", "itachi_hideout", "Generating Itachi Hideout...");
    generateStructure(player, Math.floor(player.location.x), Math.floor(player.location.y - 2), Math.floor(player.location.z), 6, 0, "wesl3y:konoha", "konoha", "Generating Konoha...");
    //generateStructure(player, 650, -430, 6, "wesl3y:orochimaru", "orochimaru_hideout", "Generating Orochimaru Hideout...");
  }
}, 20);
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                                                               
                                        
                                        
                                                                                                            
                                                                                         
                                        
                                        
                                        
                                        
                                                                                                                                                               
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                        
                                                                               
                                        
                                        
                                                                                                            
                                                                                         
                                        
                                        
                                        
                                        
                                                                                                                                                